package com.gymangy;

import java.util.Calendar;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.app.Dialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;
import android.widget.TimePicker;

public class Meal extends Activity
{
	private TextView			mTimeDisplay;

	private int					mHour;
	private int					mMinute;
	static final int			TIME_DIALOG_ID	= 0;
	protected static final int	MY_NOTE			= 0;
	public static final int		EDIT_ID			= 0001;
	public static final int		CANCEL_ID		= 0002;

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		boolean result = super.onCreateOptionsMenu(menu);
		menu.add(0, EDIT_ID, 0, R.string.menu_insert_edit);
		menu.add(0, CANCEL_ID, 1, R.string.menu_insert_cancel);
		return result;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case EDIT_ID: {
				showDialog(TIME_DIALOG_ID);

				return true;
			}
			case CANCEL_ID: {

				this.finish();
			}
		}

		return super.onOptionsItemSelected(item);
	}

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.clock_la);
		// capture our View elements
		mTimeDisplay = (TextView) findViewById(R.id.timeDisplay);

		// get the current time
		final Calendar c = Calendar.getInstance();

		mHour = c.get(Calendar.HOUR);
		mMinute = c.get(Calendar.MINUTE);

		// mHour = 2;
		// mMinute = 30;

		// display the current date
		updateDisplay();
	}

	private void updateDisplay()
	{
		mTimeDisplay.setText("Notification at "
				+ new StringBuilder().append(pad(mHour)).append(":").append(
						pad(mMinute)));
	}

	private static String pad(int c)
	{
		if (c >= 10)
			return String.valueOf(c);
		else
			return "0" + String.valueOf(c);
	}

	private void makeNotification()
	{
		Date date = new Date();
		date.setMinutes(mMinute);
		date.setHours(mHour);
		Timer timer = new Timer();
		timer.schedule(new TimerTask()
		{

			@Override
			public void run()
			{
				Notification notification = new Notification(
						android.R.drawable.star_on, "It's time to eat",
						// (time.toMillis(true) -
						// Calendar.getInstance().MILLISECOND));
						System.currentTimeMillis());
				Context context = getApplicationContext();
				Intent intent = new Intent(Meal.this, Meal.class);
				PendingIntent pendingIntent = PendingIntent.getActivity(
						context, MY_NOTE, intent, 0);
				notification.setLatestEventInfo(context, "Hey, master",
						"It's time to eat!", pendingIntent);

				notification.vibrate = new long[] { 100, 250, 100, 500 };

				NotificationManager notificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
				notificationManager.notify(MY_NOTE, notification);

			}
		}, date);
	}

	// the callback received when the user "sets" the time in the dialogprivate
	TimePickerDialog.OnTimeSetListener	mTimeSetListener	= new TimePickerDialog.OnTimeSetListener()
															{
																public void onTimeSet(
																		TimePicker view,
																		int hourOfDay,
																		int minute)
																{
																	mHour = hourOfDay;
																	mMinute = minute;
																	makeNotification();
																	updateDisplay();
																}
															};

	@Override
	protected Dialog onCreateDialog(int id)
	{
		switch (id)
		{
			case TIME_DIALOG_ID:
				return new TimePickerDialog(this, mTimeSetListener, mHour,
						mMinute, false);
		}
		return null;
	}
}