package com.gymangy;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class Program extends ListActivity
{
	public static final int	NEW_ID	= 0001;
	public static final int	EDIT_ID	= 0002;

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		boolean result = super.onCreateOptionsMenu(menu);
		menu.add(0, NEW_ID, 0, R.string.menu_insert_new);
		menu.add(0, EDIT_ID, 1, R.string.menu_insert_edit);
		return result;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case NEW_ID: {
				startActivity(new Intent(Program.this, NewProgram.class));
			}

				return true;
			case EDIT_ID:
				return true;
		}

		return super.onOptionsItemSelected(item);
	}

	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

		String[] items = getResources().getStringArray(R.array.program_items);
		setListAdapter(new ArrayAdapter<String>(this, R.layout.list_item, items));

		ListView lv = getListView();
		lv.setTextFilterEnabled(true);

		lv.setOnItemClickListener(new OnItemClickListener()
		{
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id)
			{
				Bundle bundle  = new Bundle();
				bundle.putString("parent", ((TextView) view).getText().toString());
				Intent setIntent = new Intent(Program.this, Sets.class);
				setIntent.putExtras(bundle);
				
				startActivity(setIntent);
				Toast.makeText(getApplicationContext(),
						((TextView) view).getText(), Toast.LENGTH_SHORT).show();

			}
		});
	}

}
