package com.gymangy;

import java.util.ArrayList;
import java.util.Date;

import com.database.SetDbAdapter;
import com.entities.GymSet;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class Sets extends Activity
{
	SetDbAdapter			mDb;
	EditText				set1, rep1, w1;
	EditText				set2, rep2, w2;
	EditText				set3, rep3, w3;
	EditText				set4, rep4, w4;

	public static final int	SAVE_ID		= 0001;
	public static final int	CANCEL_ID	= 0002;

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		boolean result = super.onCreateOptionsMenu(menu);
		menu.add(0, SAVE_ID, 0, R.string.menu_insert_save);
		menu.add(0, CANCEL_ID, 1, R.string.menu_insert_cancel);
		return result;
	}

	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case SAVE_ID: {
				saveToDB();
				this.finish();
				return true;
			}
			case CANCEL_ID: {
				this.finish();
				return true;
			}
		}

		return super.onOptionsItemSelected(item);
	}

	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.table_layout);

	}

	protected void saveToDB()
	{
		mDb = new SetDbAdapter(this);

		// getting parameter from previous Activity
		Bundle bundle = this.getIntent().getExtras();
		final String param = bundle.getString("parent");

		set1 = (EditText) findViewById(R.id.EditText01);
		rep1 = (EditText) findViewById(R.id.EditText11);
		w1 = (EditText) findViewById(R.id.EditText21);
		set2 = (EditText) findViewById(R.id.EditText02);
		rep2 = (EditText) findViewById(R.id.EditText12);
		w2 = (EditText) findViewById(R.id.EditText22);
		set3 = (EditText) findViewById(R.id.EditText03);
		rep3 = (EditText) findViewById(R.id.EditText13);
		w3 = (EditText) findViewById(R.id.EditText23);
		set4 = (EditText) findViewById(R.id.EditText04);
		rep4 = (EditText) findViewById(R.id.EditText14);
		w4 = (EditText) findViewById(R.id.EditText24);

		mDb.open();

		ArrayList<GymSet> list = new ArrayList<GymSet>();

		// add object if fields are not empty
		if (!rep1.getText().toString().equals("")
				&& !w1.getText().toString().equals(""))
		{
			GymSet gymSet1 = new GymSet();
			gymSet1.setSetID(new Integer(set1.getText().toString()).intValue());
			gymSet1.setRepeats(new Integer(rep1.getText().toString())
					.intValue());
			gymSet1.setWeight(new Integer(w1.getText().toString()).intValue());
			list.add(gymSet1);
		}
		if (!rep2.getText().toString().equals("")
				&& !w2.getText().toString().equals(""))
		{
			GymSet gymSet2 = new GymSet();
			gymSet2.setSetID(new Integer(set2.getText().toString()).intValue());
			gymSet2.setRepeats(new Integer(rep2.getText().toString())
					.intValue());
			gymSet2.setWeight(new Integer(w2.getText().toString()).intValue());
			list.add(gymSet2);
		}
		if (!rep3.getText().toString().equals("")
				&& !w3.getText().toString().equals(""))
		{
			GymSet gymSet3 = new GymSet();
			gymSet3.setSetID(new Integer(set3.getText().toString()).intValue());
			gymSet3.setRepeats(new Integer(rep3.getText().toString())
					.intValue());
			gymSet3.setWeight(new Integer(w3.getText().toString()).intValue());
			list.add(gymSet3);
		}
		if (!rep4.getText().toString().equals("")
				&& !w4.getText().toString().equals(""))
		{
			GymSet gymSet4 = new GymSet();
			gymSet4.setSetID(new Integer(set4.getText().toString()).intValue());
			gymSet4.setRepeats(new Integer(rep4.getText().toString())
					.intValue());
			gymSet4.setWeight(new Integer(w4.getText().toString()).intValue());
			list.add(gymSet4);
		}
		mDb.createNewRecord(param, list, new Date());
		Toast.makeText(getApplicationContext(), "Results were saved",
				Toast.LENGTH_SHORT).show();

	}
}
